"use strict";
// *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***
Object.defineProperty(exports, "__esModule", { value: true });
exports.Publication = void 0;
const pulumi = require("@pulumi/pulumi");
const utilities = require("./utilities");
/**
 * The `postgresql.Publication` resource creates and manages a publication on a PostgreSQL
 * server.
 *
 * ## Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as postgresql from "@pulumi/postgresql";
 *
 * const publication = new postgresql.Publication("publication", {
 *     name: "publication",
 *     tables: [
 *         "public.test",
 *         "another_schema.test",
 *     ],
 * });
 * ```
 *
 * ## Import Example
 *
 * Publication can be imported using this format:
 */
class Publication extends pulumi.CustomResource {
    /**
     * Get an existing Publication resource's state with the given name, ID, and optional extra
     * properties used to qualify the lookup.
     *
     * @param name The _unique_ name of the resulting resource.
     * @param id The _unique_ provider ID of the resource to lookup.
     * @param state Any extra arguments used during the lookup.
     * @param opts Optional settings to control the behavior of the CustomResource.
     */
    static get(name, id, state, opts) {
        return new Publication(name, state, Object.assign(Object.assign({}, opts), { id: id }));
    }
    /**
     * Returns true if the given object is an instance of Publication.  This is designed to work even
     * when multiple copies of the Pulumi SDK have been loaded into the same process.
     */
    static isInstance(obj) {
        if (obj === undefined || obj === null) {
            return false;
        }
        return obj['__pulumiType'] === Publication.__pulumiType;
    }
    constructor(name, argsOrState, opts) {
        let resourceInputs = {};
        opts = opts || {};
        if (opts.id) {
            const state = argsOrState;
            resourceInputs["allTables"] = state ? state.allTables : undefined;
            resourceInputs["database"] = state ? state.database : undefined;
            resourceInputs["dropCascade"] = state ? state.dropCascade : undefined;
            resourceInputs["name"] = state ? state.name : undefined;
            resourceInputs["owner"] = state ? state.owner : undefined;
            resourceInputs["publishParams"] = state ? state.publishParams : undefined;
            resourceInputs["publishViaPartitionRootParam"] = state ? state.publishViaPartitionRootParam : undefined;
            resourceInputs["tables"] = state ? state.tables : undefined;
        }
        else {
            const args = argsOrState;
            resourceInputs["allTables"] = args ? args.allTables : undefined;
            resourceInputs["database"] = args ? args.database : undefined;
            resourceInputs["dropCascade"] = args ? args.dropCascade : undefined;
            resourceInputs["name"] = args ? args.name : undefined;
            resourceInputs["owner"] = args ? args.owner : undefined;
            resourceInputs["publishParams"] = args ? args.publishParams : undefined;
            resourceInputs["publishViaPartitionRootParam"] = args ? args.publishViaPartitionRootParam : undefined;
            resourceInputs["tables"] = args ? args.tables : undefined;
        }
        opts = pulumi.mergeOptions(utilities.resourceOptsDefaults(), opts);
        super(Publication.__pulumiType, name, resourceInputs, opts);
    }
}
exports.Publication = Publication;
/** @internal */
Publication.__pulumiType = 'postgresql:index/publication:Publication';
//# sourceMappingURL=publication.js.map